include:
  - project: "${CI_PROJECT_ROOT_NAMESPACE}/ci"
    ref: "main"
    file: "/python-docker-container.yml"
  - project: "${CI_PROJECT_ROOT_NAMESPACE}/pdf/gitlab-profile"
    ref: "main"
    file: "/ci/update-group-readme-if-needed.yml"
    inputs:
      stage-name: administration
      needs-steps:
        - test

integration_test:
  stage: test
  needs: []
  image:
    name: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:latest
  services:
    - ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:dind
  before_script:
    - export RABBITMQ_PORT=$((5000 + RANDOM % 1000))
    - export RABBITMQ_CONSOLE_PORT=$((15000 + RANDOM % 1000))
    - export MINIO_PORT=$((9000 + RANDOM % 1000))
    - export MINIO_CONSOLE_PORT=$((9001 + RANDOM % 1000))
    - docker version
    - docker compose version
    - docker compose -p page-regions-${CI_PIPELINE_ID} -f docker-compose.yaml down --volumes
  script:
    - docker compose -p page-regions-${CI_PIPELINE_ID} -f docker-compose.yaml up -d --build
    - docker compose -p page-regions-${CI_PIPELINE_ID} -f docker-compose.yaml up --attach integration-test --exit-code-from integration-test
  after_script:
    - docker compose -p page-regions-${CI_PIPELINE_ID} -f docker-compose.yaml down --volumes

integration_test_cleanup:
  stage: test
  needs:
    - integration_test
  rules:
    - when: on_failure
  image:
    name: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:latest
  services:
    - ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:dind
  script:
    - docker compose -p page-regions-${CI_PIPELINE_ID} -f docker-compose.yaml down --volumes
